UIPackage
Menu

Framework

Change language

Boilerplate repo

Qr Code

qr-codeui

QR code renderer — pass `value` and a size, get a canvas PNG or SVG. Useful for sign-in links, share URLs, and Wi-Fi credentials. Depends on the `qrcode` package.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/qr-code.json
Named registry:npx shadcn-vue@latest add @uipkge/qr-codeInstalls to:app/components/ui/qr-code/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
valuestringrequired
type
'canvas''svg'
'canvas'optional
sizenumber160optional
colorstringoptional
bgColorstring'#ffffff'optional
iconstringoptional
iconSizenumber | { width: number; height: number }optional
errorLevel
'L''M''Q''H'
'M'optional
borderedbooleantrueoptional
status
'active''expired''loading''scanned'
'active'optional
marginSizenumber0optional
classHTMLAttributes['class']optional

npm dependencies

Files installed (2)

  • app/components/ui/qr-code/QRCode.vue5.3 kB
    <script setup lang="ts">
    import type { HTMLAttributes } from 'vue'
    import { computed, ref, watch } from 'vue'
    import QRCodeLib from 'qrcode'
    import { Loader2, RotateCcw, Check, ScanLine } from 'lucide-vue-next'
    import { cn } from '@/lib/utils'
    
    export type QRCodeType = 'canvas' | 'svg'
    export type QRCodeStatus = 'active' | 'expired' | 'loading' | 'scanned'
    export type QRCodeErrorLevel = 'L' | 'M' | 'Q' | 'H'
    
    const props = withDefaults(
      defineProps<{
        value: string
        type?: QRCodeType
        size?: number
        color?: string
        bgColor?: string
        icon?: string
        iconSize?: number | { width: number; height: number }
        errorLevel?: QRCodeErrorLevel
        bordered?: boolean
        status?: QRCodeStatus
        marginSize?: number
        class?: HTMLAttributes['class']
      }>(),
      {
        type: 'canvas',
        size: 160,
        // qrcode requires resolvable hex/rgb — CSS vars like var(--foreground) throw.
        color: '#000000',
        bgColor: '#ffffff',
        errorLevel: 'M',
        bordered: true,
        status: 'active',
        marginSize: 0,
      },
    )
    
    const emit = defineEmits<{
      refresh: []
    }>()
    
    const qrDataUrl = ref('')
    const qrSvg = ref('')
    const isGenerating = ref(false)
    
    const iconDimensions = computed(() => {
      if (typeof props.iconSize === 'number') {
        return { width: props.iconSize, height: props.iconSize }
      }
      return props.iconSize ?? { width: 40, height: 40 }
    })
    
    const errorCorrectionLevel = computed(() => props.errorLevel)
    
    async function generateQR() {
      if (!props.value || props.status === 'loading') return
    
      isGenerating.value = true
      try {
        const options = {
          width: props.size,
          margin: props.marginSize,
          color: {
            dark: props.color,
            light: props.bgColor,
          },
          errorCorrectionLevel: errorCorrectionLevel.value,
        }
    
        if (props.type === 'svg') {
          qrSvg.value = await QRCodeLib.toString(props.value, {
            type: 'svg',
            ...options,
          })
        } else {
          qrDataUrl.value = await QRCodeLib.toDataURL(props.value, options)
        }
      } catch (e) {
        console.error('QR Code generation failed:', e)
      } finally {
        isGenerating.value = false
      }
    }
    
    watch(
      () => [
        props.value,
        props.type,
        props.size,
        props.color,
        props.bgColor,
        props.errorLevel,
        props.marginSize,
        props.status,
      ],
      () => generateQR(),
      { immediate: true },
    )
    
    function downloadQR() {
      const link = document.createElement('a')
      link.download = `qrcode-${props.value.slice(0, 20)}.png`
      link.href = qrDataUrl.value
      link.click()
    }
    
    function handleRefresh() {
      emit('refresh')
    }
    
    const statusOverlay = computed(() => {
      switch (props.status) {
        case 'expired':
          return {
            icon: RotateCcw,
            text: 'Expired',
            action: handleRefresh,
          }
        case 'scanned':
          return {
            icon: Check,
            text: 'Scanned',
            action: null,
          }
        case 'loading':
          return {
            icon: Loader2,
            text: 'Loading...',
            action: null,
          }
        default:
          return null
      }
    })
    </script>
    
    <template>
      <div
        data-uipkge
        data-slot="qr-code"
        :aria-busy="status === 'loading' || undefined"
        :class="
          cn('inline-flex flex-col items-center gap-2', bordered && 'bg-background rounded-lg border p-4', props.class)
        "
      >
        <div
          class="relative inline-flex items-center justify-center overflow-hidden"
          :style="{ width: `${size}px`, height: `${size}px` }"
        >
          <!-- QR Code -->
          <template v-if="type === 'svg' && qrSvg">
            <div v-html="qrSvg" class="size-full" />
          </template>
          <template v-else-if="qrDataUrl">
            <img :src="qrDataUrl" :alt="`QR Code for ${value}`" class="size-full" />
          </template>
    
          <!-- Icon overlay -->
          <div v-if="icon && status === 'active'" class="absolute inset-0 flex items-center justify-center">
            <div
              class="bg-background overflow-hidden rounded-md shadow-sm"
              :style="{
                width: `${iconDimensions.width}px`,
                height: `${iconDimensions.height}px`,
              }"
            >
              <img :src="icon" alt="" class="size-full object-cover" />
            </div>
          </div>
    
          <!-- Status overlay -->
          <div
            v-if="statusOverlay"
            class="bg-background/90 absolute inset-0 flex flex-col items-center justify-center gap-2 backdrop-blur-sm"
          >
            <component :is="statusOverlay.icon" class="size-8" :class="status === 'loading' && 'animate-spin'" />
            <span class="text-foreground text-sm font-medium">{{ statusOverlay.text }}</span>
            <button
              v-if="statusOverlay.action"
              type="button"
              class="bg-primary text-primary-foreground hover:bg-primary/90 focus-visible:ring-ring inline-flex items-center gap-1 rounded-md px-3 py-1 text-xs font-medium focus-visible:ring-2 focus-visible:outline-none"
              @click="statusOverlay.action"
            >
              <ScanLine class="size-3" />
              Refresh
            </button>
          </div>
        </div>
    
        <!-- Download button -->
        <slot name="extra">
          <button
            v-if="type === 'canvas' && status === 'active' && qrDataUrl"
            type="button"
            class="text-muted-foreground hover:text-foreground focus-visible:ring-ring text-xs underline-offset-2 hover:underline focus-visible:ring-2 focus-visible:outline-none"
            @click="downloadQR"
          >
            Download
          </button>
        </slot>
      </div>
    </template>
    
  • app/components/ui/qr-code/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/vue/qr-code.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Qr Code

qr-codeui

QR code renderer — pass `value` and a size, get a canvas PNG or SVG. Useful for sign-in links, share URLs, and Wi-Fi credentials. Depends on the `qrcode` package.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/qr-code.json
Named registry:npx shadcn@latest add @uipkge-react/qr-codeInstalls to:components/ui/qr-code/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
valuestringrequired
typeQRCodeTypeoptional
sizenumberoptional
colorstringoptional
bgColorstringoptional
iconstringoptional
iconSizenumber | { width: number; height: number }optional
errorLevelQRCodeErrorLeveloptional
borderedbooleanoptional
statusQRCodeStatusoptional
marginSizenumberoptional
classNamestringoptional
onRefresh

Fired when the "Refresh" action of the expired overlay is clicked.

() => voidoptional
extra

Overrides the default download button (parity with the Vue `extra` slot).

React.ReactNodeoptional

npm dependencies

Files installed (2)

  • components/ui/qr-code/QrCode.tsx5.9 kB
    'use client'
    
    import * as React from 'react'
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore -- qrcode ships no types unless @types/qrcode (a devDependency) is installed; @ts-ignore stays valid either way
    import QRCodeLib from 'qrcode'
    import { Loader2, RotateCcw, Check, ScanLine } from 'lucide-react'
    import { cn } from '@/lib/utils'
    
    export type QRCodeType = 'canvas' | 'svg'
    export type QRCodeStatus = 'active' | 'expired' | 'loading' | 'scanned'
    export type QRCodeErrorLevel = 'L' | 'M' | 'Q' | 'H'
    
    export interface QrCodeProps {
      value: string
      type?: QRCodeType
      size?: number
      color?: string
      bgColor?: string
      icon?: string
      iconSize?: number | { width: number; height: number }
      errorLevel?: QRCodeErrorLevel
      bordered?: boolean
      status?: QRCodeStatus
      marginSize?: number
      className?: string
      /** Fired when the "Refresh" action of the expired overlay is clicked. */
      onRefresh?: () => void
      /** Overrides the default download button (parity with the Vue `extra` slot). */
      extra?: React.ReactNode
    }
    
    const QrCode = React.forwardRef<HTMLDivElement, QrCodeProps>(
      (
        {
          value,
          type = 'canvas',
          size = 160,
          color = '#000000',
          bgColor = '#ffffff',
          icon,
          iconSize,
          errorLevel = 'M',
          bordered = true,
          status = 'active',
          marginSize = 0,
          className,
          onRefresh,
          extra,
        },
        ref,
      ) => {
        const [qrDataUrl, setQrDataUrl] = React.useState('')
        const [qrSvg, setQrSvg] = React.useState('')
    
        const iconDimensions =
          typeof iconSize === 'number' ? { width: iconSize, height: iconSize } : (iconSize ?? { width: 40, height: 40 })
    
        React.useEffect(() => {
          let cancelled = false
          async function generateQR() {
            if (!value || status === 'loading') return
            try {
              const options = {
                width: size,
                margin: marginSize,
                color: { dark: color, light: bgColor },
                errorCorrectionLevel: errorLevel,
              }
              if (type === 'svg') {
                const svg = await QRCodeLib.toString(value, { type: 'svg', ...options })
                if (!cancelled) setQrSvg(svg)
              } else {
                const url = await QRCodeLib.toDataURL(value, options)
                if (!cancelled) setQrDataUrl(url)
              }
            } catch (e) {
              console.error('QR Code generation failed:', e)
            }
          }
          generateQR()
          return () => {
            cancelled = true
          }
        }, [value, type, size, color, bgColor, errorLevel, marginSize, status])
    
        function downloadQR() {
          const link = document.createElement('a')
          link.download = `qrcode-${value.slice(0, 20)}.png`
          link.href = qrDataUrl
          link.click()
        }
    
        const statusOverlay = (() => {
          switch (status) {
            case 'expired':
              return { Icon: RotateCcw, text: 'Expired', action: onRefresh ?? null }
            case 'scanned':
              return { Icon: Check, text: 'Scanned', action: null }
            case 'loading':
              return { Icon: Loader2, text: 'Loading...', action: null }
            default:
              return null
          }
        })()
    
        return (
          <div
            ref={ref}
            data-uipkge=""
            data-slot="qr-code"
            aria-busy={status === 'loading' || undefined}
            className={cn(
              'inline-flex flex-col items-center gap-2',
              bordered && 'bg-background rounded-lg border p-4',
              className,
            )}
          >
            <div
              className="relative inline-flex items-center justify-center overflow-hidden"
              style={{ width: `${size}px`, height: `${size}px` }}
            >
              {/* QR Code */}
              {type === 'svg' && qrSvg ? (
                <div className="size-full" dangerouslySetInnerHTML={{ __html: qrSvg }} />
              ) : qrDataUrl ? (
                <img src={qrDataUrl} alt={`QR Code for ${value}`} className="size-full" />
              ) : null}
    
              {/* Icon overlay */}
              {icon && status === 'active' && (
                <div className="absolute inset-0 flex items-center justify-center">
                  <div
                    className="bg-background overflow-hidden rounded-md shadow-sm"
                    style={{ width: `${iconDimensions.width}px`, height: `${iconDimensions.height}px` }}
                  >
                    <img src={icon} alt="" className="size-full object-cover" />
                  </div>
                </div>
              )}
    
              {/* Status overlay */}
              {statusOverlay && (
                <div className="bg-background/90 absolute inset-0 flex flex-col items-center justify-center gap-2 backdrop-blur-sm">
                  <statusOverlay.Icon className={cn('size-8', status === 'loading' && 'animate-spin')} />
                  <span className="text-foreground text-sm font-medium">{statusOverlay.text}</span>
                  {statusOverlay.action && (
                    <button
                      type="button"
                      className="bg-primary text-primary-foreground hover:bg-primary/90 focus-visible:ring-ring inline-flex items-center gap-1 rounded-md px-3 py-1 text-xs font-medium focus-visible:ring-2 focus-visible:outline-none"
                      onClick={statusOverlay.action}
                    >
                      <ScanLine className="size-3" />
                      Refresh
                    </button>
                  )}
                </div>
              )}
            </div>
    
            {/* Download button (overridable via the `extra` prop) */}
            {extra !== undefined
              ? extra
              : type === 'canvas' &&
                status === 'active' &&
                qrDataUrl && (
                  <button
                    type="button"
                    className="text-muted-foreground hover:text-foreground focus-visible:ring-ring text-xs underline-offset-2 hover:underline focus-visible:ring-2 focus-visible:outline-none"
                    onClick={downloadQR}
                  >
                    Download
                  </button>
                )}
          </div>
        )
      },
    )
    QrCode.displayName = 'QrCode'
    
    export { QrCode }
    
  • components/ui/qr-code/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/react/qr-code.json